from .insn_rv32i_u_type import *

"""
LUI instruction
"""

class InsnLui(InsnRV32IUType):
    def __init__(self, params):
        super().__init__(params, 0b0110111)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, self.insn_imm, 0))

        return m
