from .insn_rv32m_r_type import *

"""
REM instruction
"""

class InsnRem(InsnRV32MRType):
    def __init__(self, params):
        super().__init__(params, 0b110)
    def elaborate(self, platform):
        m = super().elaborate(platform)

        if self.params.altops:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, (self.rvfi_rs1_rdata - self.rvfi_rs2_rdata) ^ 0xf5b7d8538da68fa5, 0))
        else:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, Mux(self.rvfi_rs2_rdata == 0, self.rvfi_rs1_rdata, Mux((self.rvfi_rs1_rdata == (1 << (self.params.xlen - 1))) & (self.rvfi_rs2_rdata == 2 ** self.params.xlen - 1), 0, Value.as_signed(self.rvfi_rs1_rdata) % Value.as_signed(self.rvfi_rs2_rdata))), 0))

        return m
