from .insn_rv32m_r_type import *

"""
MULHSU instruction
"""

class InsnMulhsu(InsnRV32MRType):
    def __init__(self, params):
        super().__init__(params, 0b010)
    def elaborate(self, platform):
        m = super().elaborate(platform)

        if self.params.altops:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, (self.rvfi_rs1_rdata - self.rvfi_rs2_rdata) ^ 0xea3969edecfbe137, 0))
        else:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, (((Mux(self.rvfi_rs1_rdata[-1], 2 ** self.params.xlen - 1, 0) << self.params.xlen) | self.rvfi_rs1_rdata) * self.rvfi_rs2_rdata) >> self.params.xlen, 0))

        return m
