from .insn_rv32m_r_type import *

"""
REMU instruction
"""

class InsnRemu(InsnRV32MRType):
    def __init__(self, params):
        super().__init__(params, 0b111)
    def elaborate(self, platform):
        m = super().elaborate(platform)

        if self.params.altops:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, (self.rvfi_rs1_rdata - self.rvfi_rs2_rdata) ^ 0xbc4402413138d0e1, 0))
        else:
            m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, Mux(self.rvfi_rs2_rdata == 0, self.rvfi_rs1_rdata, self.rvfi_rs1_rdata % self.rvfi_rs2_rdata), 0))

        return m
