from .insn_rv32i_r_type import *

"""
SLT instruction
"""

class InsnSlt(InsnRV32IRType):
    def __init__(self, params):
        super().__init__(params, 0b0000000, 0b010, 0b0110011)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, Value.as_signed(self.rvfi_rs1_rdata) < Value.as_signed(self.rvfi_rs2_rdata), 0))

        return m
