from .insn_rv32i_r_type import *

"""
SUB instruction
"""

class InsnSub(InsnRV32IRType):
    def __init__(self, params):
        super().__init__(params, 0b0100000, 0b000, 0b0110011)

    def elaborate(self, platform):
        m = super().elaborate(platform)

        m.d.comb += self.spec_rd_wdata.eq(Mux(self.spec_rd_addr, self.rvfi_rs1_rdata - self.rvfi_rs2_rdata, 0))

        return m
